/* f2c.h  --  Standard Fortran to C header file */

/**  barf  [ba:rf]  2.  "He suggested using FORTRAN, and everybody barfed."

	- From The Shogakukan DICTIONARY OF NEW ENGLISH (Second edition) */

#ifndef F2C_INCLUDE
#define F2C_INCLUDE

typedef long int integer;
typedef unsigned long int uinteger;
typedef char *address;
typedef short int shortint;
typedef float real;
typedef double doublereal;
typedef struct { real r, i; } complex;
typedef struct { doublereal r, i; } doublecomplex;
typedef long int logical;
typedef short int shortlogical;
typedef char logical1;
typedef char integer1;
#ifdef INTEGER_STAR_8	/* Adjust for integer*8. */
typedef long long longint;		/* system-dependent */
typedef unsigned long long ulongint;	/* system-dependent */
#define qbit_clear(a,b)	((a) & ~((ulongint)1 << (b)))
#define qbit_set(a,b)	((a) |  ((ulongint)1 << (b)))
#endif

#define TRUE_ (1)
#define FALSE_ (0)

/* Extern is for use with -E */
#ifndef Extern
#define Extern extern
#endif

/* I/O stuff */

#ifdef f2c_i2
/* for -i2 */
typedef short flag;
typedef short ftnlen;
typedef short ftnint;
#else
typedef long int flag;
typedef long int ftnlen;
typedef long int ftnint;
#endif

/*external read, write*/
typedef struct
{	flag cierr;
	ftnint ciunit;
	flag ciend;
	char *cifmt;
	ftnint cirec;
} cilist;

/*internal read, write*/
typedef struct
{	flag icierr;
	char *iciunit;
	flag iciend;
	char *icifmt;
	ftnint icirlen;
	ftnint icirnum;
} icilist;

/*open*/
typedef struct
{	flag oerr;
	ftnint ounit;
	char *ofnm;
	ftnlen ofnmlen;
	char *osta;
	char *oacc;
	char *ofm;
	ftnint orl;
	char *oblnk;
} olist;

/*close*/
typedef struct
{	flag cerr;
	ftnint cunit;
	char *csta;
} cllist;

/*rewind, backspace, endfile*/
typedef struct
{	flag aerr;
	ftnint aunit;
} alist;

/* inquire */
typedef struct
{	flag inerr;
	ftnint inunit;
	char *infile;
	ftnlen infilen;
	ftnint	*inex;	/*parameters in standard's order*/
	ftnint	*inopen;
	ftnint	*innum;
	ftnint	*innamed;
	char	*inname;
	ftnlen	innamlen;
	char	*inacc;
	ftnlen	inacclen;
	char	*inseq;
	ftnlen	inseqlen;
	char 	*indir;
	ftnlen	indirlen;
	char	*infmt;
	ftnlen	infmtlen;
	char	*inform;
	ftnint	informlen;
	char	*inunf;
	ftnlen	inunflen;
	ftnint	*inrecl;
	ftnint	*innrec;
	char	*inblank;
	ftnlen	inblanklen;
} inlist;

#define VOID void

union Multitype {	/* for multiple entry points */
	integer1 g;
	shortint h;
	integer i;
	/* longint j; */
	real r;
	doublereal d;
	complex c;
	doublecomplex z;
	};

typedef union Multitype Multitype;

/*typedef long int Long;*/	/* No longer used; formerly in Namelist */

struct Vardesc {	/* for Namelist */
	char *name;
	char *addr;
	ftnlen *dims;
	int  type;
	};
typedef struct Vardesc Vardesc;

struct Namelist {
	char *name;
	Vardesc **vars;
	int nvars;
	};
typedef struct Namelist Namelist;

#define abs(x) ((x) >= 0 ? (x) : -(x))
#define dabs(x) (doublereal)abs(x)
#define min(a,b) ((a) <= (b) ? (a) : (b))
#define max(a,b) ((a) >= (b) ? (a) : (b))
#define dmin(a,b) (doublereal)min(a,b)
#define dmax(a,b) (doublereal)max(a,b)
#define bit_test(a,b)	((a) >> (b) & 1)
#define bit_clear(a,b)	((a) & ~((uinteger)1 << (b)))
#define bit_set(a,b)	((a) |  ((uinteger)1 << (b)))

/* procedure parameter types for -A and -C++ */

#define F2C_proc_par_types 1
#ifdef __cplusplus
typedef int /* Unknown procedure type */ (*U_fp)(...);
typedef shortint (*J_fp)(...);
typedef integer (*I_fp)(...);
typedef real (*R_fp)(...);
typedef doublereal (*D_fp)(...), (*E_fp)(...);
typedef /* Complex */ VOID (*C_fp)(...);
typedef /* Double Complex */ VOID (*Z_fp)(...);
typedef logical (*L_fp)(...);
typedef shortlogical (*K_fp)(...);
typedef /* Character */ VOID (*H_fp)(...);
typedef /* Subroutine */ int (*S_fp)(...);
#else
typedef int /* Unknown procedure type */ (*U_fp)();
typedef shortint (*J_fp)();
typedef integer (*I_fp)();
typedef real (*R_fp)();
typedef doublereal (*D_fp)(), (*E_fp)();
typedef /* Complex */ VOID (*C_fp)();
typedef /* Double Complex */ VOID (*Z_fp)();
typedef logical (*L_fp)();
typedef shortlogical (*K_fp)();
typedef /* Character */ VOID (*H_fp)();
typedef /* Subroutine */ int (*S_fp)();
#endif
/* E_fp is for real functions when -R is not specified */
typedef VOID C_f;	/* complex function */
typedef VOID H_f;	/* character function */
typedef VOID Z_f;	/* double complex function */
typedef doublereal E_f;	/* real function with -R not specified */

/* undef any lower-case symbols that your C compiler predefines, e.g.: */

#ifndef Skip_f2c_Undefs
#undef cray
#undef gcos
#undef mc68010
#undef mc68020
#undef mips
#undef pdp11
#undef sgi
#undef sparc
#undef sun
#undef sun2
#undef sun3
#undef sun4
#undef u370
#undef u3b
#undef u3b2
#undef u3b5
#undef unix
#undef vax
#endif
#endif

/* If you are using a C++ compiler, append the following to f2c.h
   for compiling libF77 and libI77. */

#ifdef __cplusplus
extern "C" {
#endif
extern int __cdecl abort_(void);
extern double __cdecl c_abs(complex *);
extern void __cdecl c_cos(complex *, complex *);
extern void __cdecl c_div(complex *, complex *, complex *);
extern void __cdecl c_exp(complex *, complex *);
extern void __cdecl c_log(complex *, complex *);
extern void __cdecl c_sin(complex *, complex *);
extern void __cdecl c_sqrt(complex *, complex *);
extern double __cdecl d_abs(double *);
extern double __cdecl d_acos(double *);
extern double __cdecl d_asin(double *);
extern double __cdecl d_atan(double *);
extern double __cdecl d_atn2(double *, double *);
extern void __cdecl d_cnjg(doublecomplex *, doublecomplex *);
extern double __cdecl d_cos(double *);
extern double __cdecl d_cosh(double *);
extern double __cdecl d_dim(double *, double *);
extern double __cdecl d_exp(double *);
extern double __cdecl d_imag(doublecomplex *);
extern double __cdecl d_int(double *);
extern double __cdecl d_lg10(double *);
extern double __cdecl d_log(double *);
extern double __cdecl d_mod(double *, double *);
extern double __cdecl d_nint(double *);
extern double __cdecl d_prod(float *, float *);
extern double __cdecl d_sign(double *, double *);
extern double __cdecl d_sin(double *);
extern double __cdecl d_sinh(double *);
extern double __cdecl d_sqrt(double *);
extern double __cdecl d_tan(double *);
extern double __cdecl d_tanh(double *);
extern double __cdecl derf_(double *);
extern double __cdecl derfc_(double *);
extern integer __cdecl do_fio(ftnint *, char *, ftnlen);
extern integer __cdecl do_lio(ftnint *, ftnint *, char *, ftnlen);
extern integer __cdecl do_uio(ftnint *, char *, ftnlen);
extern integer __cdecl e_rdfe(void);
extern integer __cdecl e_rdue(void);
extern integer __cdecl e_rsfe(void);
extern integer __cdecl e_rsfi(void);
extern integer __cdecl e_rsle(void);
extern integer __cdecl e_rsli(void);
extern integer __cdecl e_rsue(void);
extern integer __cdecl e_wdfe(void);
extern integer __cdecl e_wdue(void);
extern integer __cdecl e_wsfe(void);
extern integer __cdecl e_wsfi(void);
extern integer __cdecl e_wsle(void);
extern integer __cdecl e_wsli(void);
extern integer __cdecl e_wsue(void);
extern int __cdecl ef1asc_(ftnint *, ftnlen *, ftnint *, ftnlen *);
extern integer __cdecl ef1cmc_(ftnint *, ftnlen *, ftnint *, ftnlen *);
extern double __cdecl erf(double);
extern double __cdecl erf_(float *);
extern double __cdecl erfc(double);
extern double __cdecl erfc_(float *);
extern integer __cdecl f_back(alist *);
extern integer __cdecl f_clos(cllist *);
extern integer __cdecl f_end(alist *);
extern void __cdecl f_exit(void);
extern integer __cdecl f_inqu(inlist *);
extern integer __cdecl f_open(olist *);
extern integer __cdecl f_rew(alist *);
extern int __cdecl flush_(void);
extern void __cdecl getarg_(integer *, char *, ftnlen);
extern void __cdecl getenv_(char *, char *, ftnlen, ftnlen);
extern short __cdecl h_abs(short *);
extern short __cdecl h_dim(short *, short *);
extern short __cdecl h_dnnt(double *);
extern short __cdecl h_indx(char *, char *, ftnlen, ftnlen);
extern short __cdecl h_len(char *, ftnlen);
extern short __cdecl h_mod(short *, short *);
extern short __cdecl h_nint(float *);
extern short __cdecl h_sign(short *, short *);
extern short __cdecl hl_ge(char *, char *, ftnlen, ftnlen);
extern short __cdecl hl_gt(char *, char *, ftnlen, ftnlen);
extern short __cdecl hl_le(char *, char *, ftnlen, ftnlen);
extern short __cdecl hl_lt(char *, char *, ftnlen, ftnlen);
extern integer __cdecl i_abs(integer *);
extern integer __cdecl i_dim(integer *, integer *);
extern integer __cdecl i_dnnt(double *);
extern integer __cdecl i_indx(char *, char *, ftnlen, ftnlen);
extern integer __cdecl i_len(char *, ftnlen);
extern integer __cdecl i_mod(integer *, integer *);
extern integer __cdecl i_nint(float *);
extern integer __cdecl i_sign(integer *, integer *);
extern integer __cdecl iargc_(void);
extern ftnlen __cdecl l_ge(char *, char *, ftnlen, ftnlen);
extern ftnlen __cdecl l_gt(char *, char *, ftnlen, ftnlen);
extern ftnlen __cdecl l_le(char *, char *, ftnlen, ftnlen);
extern ftnlen __cdecl l_lt(char *, char *, ftnlen, ftnlen);
extern void __cdecl pow_ci(complex *, complex *, integer *);
extern double __cdecl pow_dd(double *, double *);
extern double __cdecl pow_di(double *, integer *);
extern short __cdecl pow_hh(short *, shortint *);
extern integer __cdecl pow_ii(integer *, integer *);
extern double __cdecl pow_ri(float *, integer *);
extern void __cdecl pow_zi(doublecomplex *, doublecomplex *, integer *);
extern void __cdecl pow_zz(doublecomplex *, doublecomplex *, doublecomplex *);
extern double __cdecl r_abs(float *);
extern double __cdecl r_acos(float *);
extern double __cdecl r_asin(float *);
extern double __cdecl r_atan(float *);
extern double __cdecl r_atn2(float *, float *);
extern void __cdecl r_cnjg(complex *, complex *);
extern double __cdecl r_cos(float *);
extern double __cdecl r_cosh(float *);
extern double __cdecl r_dim(float *, float *);
extern double __cdecl r_exp(float *);
extern double __cdecl r_imag(complex *);
extern double __cdecl r_int(float *);
extern double __cdecl r_lg10(float *);
extern double __cdecl r_log(float *);
extern double __cdecl r_mod(float *, float *);
extern double __cdecl r_nint(float *);
extern double __cdecl r_sign(float *, float *);
extern double __cdecl r_sin(float *);
extern double __cdecl r_sinh(float *);
extern double __cdecl r_sqrt(float *);
extern double __cdecl r_tan(float *);
extern double __cdecl r_tanh(float *);
extern void __cdecl s_cat(char *, char **, integer *, integer *, ftnlen);
extern integer __cdecl s_cmp(char *, char *, ftnlen, ftnlen);
extern void __cdecl s_copy(char *, char *, ftnlen, ftnlen);
extern int __cdecl s_paus(char *, ftnlen);
extern integer __cdecl s_rdfe(cilist *);
extern integer __cdecl s_rdue(cilist *);
extern integer __cdecl s_rnge(char *, integer, char *, integer);
extern integer __cdecl s_rsfe(cilist *);
extern integer __cdecl s_rsfi(icilist *);
extern integer __cdecl s_rsle(cilist *);
extern integer __cdecl s_rsli(icilist *);
extern integer __cdecl s_rsne(cilist *);
extern integer __cdecl s_rsni(icilist *);
extern integer __cdecl s_rsue(cilist *);
extern int __cdecl s_stop(char *, ftnlen);
extern integer __cdecl s_wdfe(cilist *);
extern integer __cdecl s_wdue(cilist *);
extern integer __cdecl s_wsfe(cilist *);
extern integer __cdecl s_wsfi(icilist *);
extern integer __cdecl s_wsle(cilist *);
extern integer __cdecl s_wsli(icilist *);
extern integer __cdecl s_wsne(cilist *);
extern integer __cdecl s_wsni(icilist *);
extern integer __cdecl s_wsue(cilist *);
extern void __cdecl sig_die(char *, int);
extern integer __cdecl signal_(integer *, void (*)(int));
extern integer __cdecl system_(char *, ftnlen);
extern double __cdecl z_abs(doublecomplex *);
extern void __cdecl z_cos(doublecomplex *, doublecomplex *);
extern void __cdecl z_div(doublecomplex *, doublecomplex *, doublecomplex *);
extern void __cdecl z_exp(doublecomplex *, doublecomplex *);
extern void __cdecl z_log(doublecomplex *, doublecomplex *);
extern void __cdecl z_sin(doublecomplex *, doublecomplex *);
extern void __cdecl z_sqrt(doublecomplex *, doublecomplex *);
#ifdef __cplusplus
	}
#endif
